/*********************************************************************************************************
*
* File                : main.c
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM  Version: 4.20
* Version             : V1.0
* By                  : 
*
*                                  (c) Copyright 2005-2011, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include <string.h>
#include <stdio.h>
#include  <math.h>
#include "I2C.h"
#include "LSM303.h"
#include "usart.h"

//#define STEP 1
//#define STEP 2
//#define STEP 3
#define STEP 4

/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void Delay(uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
int main(void)
{
	float MagRaw[3];												//ԭʼ
	float temp0,temp1,temp2;								//ʱ
	float B[6];															//У׼B
	float MagOffsetX,MagOffsetY,MagOffsetZ;	//ƫ
	float MagAdjustX,MagAdjustY,MagAdjustZ;	//У׼ֵ
	
	float Xmax,Xmin;												//XСֵ
	float Ymax,Ymin;												//YСֵ
	float Zmax,Zmin;												//ZСֵ
	float Xoffset,Yoffset,Zoffset;					//ֵ
	
  USART_Configuration();
	I2C_Configuration();
	printf("\r\n**********************\r\n");

  LSM303M_Init();
	
  printf("\r\n****************************************************************\r\n");

  while (1)
  {
#if STEP == 1			//STEP1
		//ԭʼ
		LAM303M_Raed(MagRaw);
		
		//ԭʼǶ
		printf("AngleRaw=%f \r\n",atan2(MagRaw[1], MagRaw[0]) * (180 / 3.14159265) + 180);
	
		//ʱ
		Delay(700000);
#elif STEP == 2		//STEP2
		//ԭʼ
		LAM303M_Raed(MagRaw);

		//ʽУ׼ݣ뵽Excel
		printf("%f,%f,%f\r\n",MagRaw[0],MagRaw[1],MagRaw[2]);
		
		//ʱ
		Delay(700000);
#elif STEP == 3		//STEP3  
		//ԭʼ
		LAM303M_Raed(MagRaw);
	
		//У׼󽫲οд˴
		B[0] = 0.978484027664441;
		B[1] = 0.00287290609385101;
		B[2] = 0.0165550877852287;
		B[3] = 0.995040513920622;
		B[4] = 0.007569142974333;
		B[5] = 1.02742853739449;
		MagOffsetX = 37.7548098250416;
		MagOffsetY = -25.0457322108957;
		MagOffsetZ = 59.2978048468999;
		
		//ԭʼУ׼
		temp0 = MagRaw[0] - MagOffsetX;
		temp1 = MagRaw[1] - MagOffsetY;
		temp2 = MagRaw[2] - MagOffsetZ;
		MagAdjustX = B[0]*temp0 + B[1]*temp1 + B[2]*temp2;
		MagAdjustY = B[1]*temp0 + B[3]*temp1 + B[4]*temp2;
		MagAdjustZ = B[2]*temp0 + B[4]*temp1 + B[5]*temp2;
		
		//У׼
		printf("%f,%f,%f ",MagAdjustX,MagAdjustY,MagAdjustZ);
		
		//У׼ĽǶ
		printf("AngleAdjust=%f  \r\n",atan2(MagAdjustY, MagAdjustX) * (180 / 3.14159265) + 180);
		
		//ʱ
		Delay(700000);
#elif STEP == 4		//STEP4 
		//ԭʼ
		LAM303M_Raed(MagRaw);
		
		if (MagRaw[0] > Xmax)
			Xmax = MagRaw[0];
		
		if (MagRaw[0] < Xmin)
			Xmin = MagRaw[0];
		
		if (MagRaw[1] > Ymax)
			Ymax = MagRaw[1];
		
		if (MagRaw[1] < Ymin)
			Ymin = MagRaw[1];
		
		if (MagRaw[2] > Zmax)
			Zmax = MagRaw[2];
		
		if (MagRaw[2] < Zmin)
			Zmin = MagRaw[2];
		
		Xoffset = (Xmax + Xmin) / 2;
		Yoffset = (Ymax + Xmin) / 2;
		Zoffset = (Zmax + Xmin) / 2;
		
		printf("%f %f  %f %f  %f %f--", Xmax, Xmin, Ymax, Ymin, Zmax, Zmin);
		
		printf("AngleAdjust=%f \r\n",atan2(MagRaw[1]-Yoffset, MagRaw[0]-Xoffset) * (180 / 3.14159265) + 180);
		
		//ʱ
		Delay(700000);
#endif
	}
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/

